#ifndef _HipRecord_h_
#define _HipRecord_h_

#include <string>

class HipRecord {
  public:
    HipRecord() {}
    bool ParseRecord(const std::string& line);
    std::string get_line() { return fLine; }
    void set_line(const std::string& line) { fLine = line; }
    std::string get_Catalog() { return fCatalog; }
    void set_Catalog(std::string newval) { fCatalog = newval; }
    int get_HIP() { return fHIP; }
    void set_HIP(int newval) { fHIP = newval; }
    std::string get_Proxy() { return fProxy; }
    void set_Proxy(std::string newval) { fProxy = newval; }
    std::string get_RAhms() { return fRAhms; }
    void set_RAhms(std::string newval) { fRAhms = newval; }
    std::string get_DEdms() { return fDEdms; }
    void set_DEdms(std::string newval) { fDEdms = newval; }
    float get_Vmag() { return fVmag; }
    void set_Vmag(float newval) { fVmag = newval; }
    char get_VarFlag() { return fVarFlag; }
    void set_VarFlag(char newval) { fVarFlag = newval; }
    std::string get_r_Vmag() { return fr_Vmag; }
    void set_r_Vmag(std::string newval) { fr_Vmag = newval; }
    double get_RAdeg() { return fRAdeg; }
    void set_RAdeg(double newval) { fRAdeg = newval; }
    double get_DEdeg() { return fDEdeg; }
    void set_DEdeg(double newval) { fDEdeg = newval; }
    std::string get_AstroRef() { return fAstroRef; }
    void set_AstroRef(std::string newval) { fAstroRef = newval; }
    float get_Plx() { return fPlx; }
    void set_Plx(float newval) { fPlx = newval; }
    double get_pmRA() { return fpmRA; }
    void set_pmRA(double newval) { fpmRA = newval; }
    double get_pmDE() { return fpmDE; }
    void set_pmDE(double newval) { fpmDE = newval; }
    float get_e_RAdeg() { return fe_RAdeg; }
    void set_e_RAdeg(float newval) { fe_RAdeg = newval; }
    float get_e_DEdeg() { return fe_DEdeg; }
    void set_e_DEdeg(float newval) { fe_DEdeg = newval; }
    float get_e_Plx() { return fe_Plx; }
    void set_e_Plx(float newval) { fe_Plx = newval; }
    float get_e_pmRA() { return fe_pmRA; }
    void set_e_pmRA(float newval) { fe_pmRA = newval; }
    float get_e_pmDE() { return fe_pmDE; }
    void set_e_pmDE(float newval) { fe_pmDE = newval; }
    float get_DE_RA() { return fDE_RA; }
    void set_DE_RA(float newval) { fDE_RA = newval; }
    float get_Plx_RA() { return fPlx_RA; }
    void set_Plx_RA(float newval) { fPlx_RA = newval; }
    float get_Plx_DE() { return fPlx_DE; }
    void set_Plx_DE(float newval) { fPlx_DE = newval; }
    float get_pmRA_RA() { return fpmRA_RA; }
    void set_pmRA_RA(float newval) { fpmRA_RA = newval; }
    float get_pmRA_DE() { return fpmRA_DE; }
    void set_pmRA_DE(float newval) { fpmRA_DE = newval; }
    float get_pmRA_Plx() { return fpmRA_Plx; }
    void set_pmRA_Plx(float newval) { fpmRA_Plx = newval; }
    float get_pmDE_RA() { return fpmDE_RA; }
    void set_pmDE_RA(float newval) { fpmDE_RA = newval; }
    float get_pmDE_DE() { return fpmDE_DE; }
    void set_pmDE_DE(float newval) { fpmDE_DE = newval; }
    float get_pmDE_Plx() { return fpmDE_Plx; }
    void set_pmDE_Plx(float newval) { fpmDE_Plx = newval; }
    float get_pmDE_pmRA() { return fpmDE_pmRA; }
    void set_pmDE_pmRA(float newval) { fpmDE_pmRA = newval; }
    short int get_F1() { return fF1; }
    void set_F1(short int newval) { fF1 = newval; }
    float get_F2() { return fF2; }
    void set_F2(float newval) { fF2 = newval; }
    float get_BTmag() { return fBTmag; }
    void set_BTmag(float newval) { fBTmag = newval; }
    float get_e_BTmag() { return fe_BTmag; }
    void set_e_BTmag(float newval) { fe_BTmag = newval; }
    float get_VTmag() { return fVTmag; }
    void set_VTmag(float newval) { fVTmag = newval; }
    float get_e_VTmag() { return fe_VTmag; }
    void set_e_VTmag(float newval) { fe_VTmag = newval; }
    std::string get_m_BTmag() { return fm_BTmag; }
    void set_m_BTmag(std::string newval) { fm_BTmag = newval; }
    float get_B_V() { return fB_V; }
    void set_B_V(float newval) { fB_V = newval; }
    float get_e_B_V() { return fe_B_V; }
    void set_e_B_V(float newval) { fe_B_V = newval; }
    std::string get_r_B_V() { return fr_B_V; }
    void set_r_B_V(std::string newval) { fr_B_V = newval; }
    float get_V_I() { return fV_I; }
    void set_V_I(float newval) { fV_I = newval; }
    float get_e_V_I() { return fe_V_I; }
    void set_e_V_I(float newval) { fe_V_I = newval; }
    std::string get_r_V_I() { return fr_V_I; }
    void set_r_V_I(std::string newval) { fr_V_I = newval; }
    std::string get_CombMag() { return fCombMag; }
    void set_CombMag(std::string newval) { fCombMag = newval; }
    float get_Hpmag() { return fHpmag; }
    void set_Hpmag(float newval) { fHpmag = newval; }
    float get_e_Hpmag() { return fe_Hpmag; }
    void set_e_Hpmag(float newval) { fe_Hpmag = newval; }
    float get_Hpscat() { return fHpscat; }
    void set_Hpscat(float newval) { fHpscat = newval; }
    short int get_o_Hpmag() { return fo_Hpmag; }
    void set_o_Hpmag(short int newval) { fo_Hpmag = newval; }
    std::string get_m_Hpmag() { return fm_Hpmag; }
    void set_m_Hpmag(std::string newval) { fm_Hpmag = newval; }
    float get_Hpmax() { return fHpmax; }
    void set_Hpmax(float newval) { fHpmax = newval; }
    float get_HPmin() { return fHPmin; }
    void set_HPmin(float newval) { fHPmin = newval; }
    float get_Period() { return fPeriod; }
    void set_Period(float newval) { fPeriod = newval; }
    std::string get_HvarType() { return fHvarType; }
    void set_HvarType(std::string newval) { fHvarType = newval; }
    std::string get_moreVar() { return fmoreVar; }
    void set_moreVar(std::string newval) { fmoreVar = newval; }
    std::string get_morePhoto() { return fmorePhoto; }
    void set_morePhoto(std::string newval) { fmorePhoto = newval; }
    std::string get_CCDM() { return fCCDM; }
    void set_CCDM(std::string newval) { fCCDM = newval; }
    std::string get_n_CCDM() { return fn_CCDM; }
    void set_n_CCDM(std::string newval) { fn_CCDM = newval; }
    char get_Nsys() { return fNsys; }
    void set_Nsys(char newval) { fNsys = newval; }
    char get_Ncomp() { return fNcomp; }
    void set_Ncomp(char newval) { fNcomp = newval; }
    std::string get_MultFlag() { return fMultFlag; }
    void set_MultFlag(std::string newval) { fMultFlag = newval; }
    std::string get_Source() { return fSource; }
    void set_Source(std::string newval) { fSource = newval; }
    std::string get_Qual() { return fQual; }
    void set_Qual(std::string newval) { fQual = newval; }
    std::string get_m_HIP() { return fm_HIP; }
    void set_m_HIP(std::string newval) { fm_HIP = newval; }
    short int get_theta() { return ftheta; }
    void set_theta(short int newval) { ftheta = newval; }
    float get_rho() { return frho; }
    void set_rho(float newval) { frho = newval; }
    float get_e_rho() { return fe_rho; }
    void set_e_rho(float newval) { fe_rho = newval; }
    float get_dHp() { return fdHp; }
    void set_dHp(float newval) { fdHp = newval; }
    float get_e_dHp() { return fe_dHp; }
    void set_e_dHp(float newval) { fe_dHp = newval; }
    std::string get_Survey() { return fSurvey; }
    void set_Survey(std::string newval) { fSurvey = newval; }
    std::string get_Chart() { return fChart; }
    void set_Chart(std::string newval) { fChart = newval; }
    std::string get_Notes() { return fNotes; }
    void set_Notes(std::string newval) { fNotes = newval; }
    int get_HD() { return fHD; }
    void set_HD(int newval) { fHD = newval; }
    std::string get_BD() { return fBD; }
    void set_BD(std::string newval) { fBD = newval; }
    std::string get_CoD() { return fCoD; }
    void set_CoD(std::string newval) { fCoD = newval; }
    std::string get_CPD() { return fCPD; }
    void set_CPD(std::string newval) { fCPD = newval; }
    float get__V_I_red() { return f_V_I_red; }
    void set__V_I_red(float newval) { f_V_I_red = newval; }
    std::string get_SpType() { return fSpType; }
    void set_SpType(std::string newval) { fSpType = newval; }
    std::string get_r_SpType() { return fr_SpType; }
    void set_r_SpType(std::string newval) { fr_SpType = newval; }

  private:
    std::string fLine;
    std::string fCatalog;/*       1  A1    ---     Catalog   [H] Catalogue (H=Hipparcos)               (H0) */
    int fHIP;            /*   9- 14  I6    ---     HIP       Identifier (HIP number)                   (H1) */
    std::string fProxy;  /*      16  A1    ---     Proxy     [HT] Proximity flag                       (H2) */
    std::string fRAhms;  /*  18- 28  A11   ---     RAhms    *Right ascension in h m s, ICRS (Eq=J2000) (H3) */
    std::string fDEdms;  /*  30- 40  A11   ---     DEdms    *Declination in deg ' ", ICRS (Eq=J2000)   (H4) */
    float fVmag;         /*  42- 46  F5.2  mag     Vmag      ? Magnitude in Johnson V                  (H5) */
    char fVarFlag;       /*      48  I1    ---     VarFlag  *[1,3]? Coarse variability flag            (H6) */
    std::string fr_Vmag; /*      50  A1    ---   r_Vmag     *[GHT] Source of magnitude                 (H7) */
    double fRAdeg;       /*  52- 63  F12.8 deg     RAdeg    *? alpha, degrees (ICRS, Eq=J2000)         (H8) */
    double fDEdeg;       /*  65- 76  F12.8 deg     DEdeg    *? delta, degrees (ICRS, Eq=J2000)         (H9) */
    std::string fAstroRef;/*      78  A1    ---     AstroRef *[*+A-Z] Reference flag for astrometry    (H10) */
    float fPlx;          /*  80- 86  F7.2  mas     Plx       ? Trigonometric parallax                 (H11) */
    double fpmRA;        /*  88- 95  F8.2 mas/yr   pmRA      ? Proper motion mu_alpha.cos(delta), ICRS(H12) */
    double fpmDE;        /*  97-104  F8.2 mas/yr   pmDE      ? Proper motion mu_delta, ICRS           (H13) */
    float fe_RAdeg;      /* 106-111  F6.2  mas   e_RAdeg     ? Standard error in RA*cos(DEdeg)        (H14) */
    float fe_DEdeg;      /* 113-118  F6.2  mas   e_DEdeg     ? Standard error in DE                   (H15) */
    float fe_Plx;        /* 120-125  F6.2  mas   e_Plx       ? Standard error in Plx                  (H16) */
    float fe_pmRA;       /* 127-132  F6.2 mas/yr e_pmRA      ? Standard error in pmRA                 (H17) */
    float fe_pmDE;       /* 134-139  F6.2 mas/yr e_pmDE      ? Standard error in pmDE                 (H18) */
    float fDE_RA;        /* 141-145  F5.2  ---     DE:RA     [-1/1]? Correlation, DE/RA*cos(delta)    (H19) */
    float fPlx_RA;       /* 147-151  F5.2  ---     Plx:RA    [-1/1]? Correlation, Plx/RA*cos(delta)   (H20) */
    float fPlx_DE;       /* 153-157  F5.2  ---     Plx:DE    [-1/1]? Correlation, Plx/DE              (H21) */
    float fpmRA_RA;      /* 159-163  F5.2  ---     pmRA:RA   [-1/1]? Correlation, pmRA/RA*cos(delta)  (H22) */
    float fpmRA_DE;      /* 165-169  F5.2  ---     pmRA:DE   [-1/1]? Correlation, pmRA/DE             (H23) */
    float fpmRA_Plx;     /* 171-175  F5.2  ---     pmRA:Plx  [-1/1]? Correlation, pmRA/Plx            (H24) */
    float fpmDE_RA;      /* 177-181  F5.2  ---     pmDE:RA   [-1/1]? Correlation, pmDE/RA*cos(delta)  (H25) */
    float fpmDE_DE;      /* 183-187  F5.2  ---     pmDE:DE   [-1/1]? Correlation, pmDE/DE             (H26) */
    float fpmDE_Plx;     /* 189-193  F5.2  ---     pmDE:Plx  [-1/1]? Correlation, pmDE/Plx            (H27) */
    float fpmDE_pmRA;    /* 195-199  F5.2  ---     pmDE:pmRA [-1/1]? Correlation, pmDE/pmRA           (H28) */
    short int fF1;       /* 201-203  I3    %       F1        ? Percentage of rejected data            (H29) */
    float fF2;           /* 205-209  F5.2  ---     F2       *? Goodness-of-fit parameter              (H30) */
    float fBTmag;        /* 218-223  F6.3  mag     BTmag     ? Mean BT magnitude                      (H32) */
    float fe_BTmag;      /* 225-229  F5.3  mag   e_BTmag     ? Standard error on BTmag                (H33) */
    float fVTmag;        /* 231-236  F6.3  mag     VTmag     ? Mean VT magnitude                      (H34) */
    float fe_VTmag;      /* 238-242  F5.3  mag   e_VTmag     ? Standard error on VTmag                (H35) */
    std::string fm_BTmag;/*     244  A1    ---   m_BTmag    *[A-Z*-] Reference flag for BT and VTmag  (H36) */
    float fB_V;          /* 246-251  F6.3  mag     B-V       ? Johnson B-V colour                     (H37) */
    float fe_B_V;        /* 253-257  F5.3  mag   e_B-V       ? Standard error on B-V                  (H38) */
    std::string fr_B_V;  /*     259  A1    ---   r_B-V       [GT] Source of B-V from Ground or Tycho  (H39) */
    float fV_I;          /* 261-264  F4.2  mag     V-I       ? Colour index in Cousins' system        (H40) */
    float fe_V_I;        /* 266-269  F4.2  mag   e_V-I       ? Standard error on V-I                  (H41) */
    std::string fr_V_I;  /*     271  A1    ---   r_V-I      *[A-T] Source of V-I                      (H42) */
    std::string fCombMag;/*     273  A1    ---     CombMag   [*] Flag for combined Vmag, B-V, V-I     (H43) */
    float fHpmag;        /* 275-281  F7.4  mag     Hpmag    *? Median magnitude in Hipparcos system   (H44) */
    float fe_Hpmag;      /* 283-288  F6.4  mag   e_Hpmag    *? Standard error on Hpmag                (H45) */
    float fHpscat;       /* 290-294  F5.3  mag     Hpscat    ? Scatter on Hpmag                       (H46) */
    short int fo_Hpmag;  /* 296-298  I3    ---   o_Hpmag     ? Number of observations for Hpmag       (H47) */
    std::string fm_Hpmag;/*     300  A1    ---   m_Hpmag    *[A-Z*-] Reference flag for Hpmag         (H48) */
    float fHpmax;        /* 302-306  F5.2  mag     Hpmax     ? Hpmag at maximum (5th percentile)      (H49) */
    float fHPmin;        /* 308-312  F5.2  mag     HPmin     ? Hpmag at minimum (95th percentile)     (H50) */
    float fPeriod;       /* 314-320  F7.2  d       Period    ? Variability period (days)              (H51) */
    std::string fHvarType;/*     322  A1    ---     HvarType *[CDMPRU]? variability type               (H52) */
    std::string fmoreVar;/*     324  A1    ---     moreVar  *[12] Additional data about variability   (H53) */
    std::string fmorePhoto;/*     326  A1    ---     morePhoto [ABC] Light curve Annex                  (H54) */
    std::string fCCDM;   /* 328-337  A10   ---     CCDM      CCDM identifier                          (H55) */
    std::string fn_CCDM; /*     339  A1    ---   n_CCDM     *[HIM] Historical status flag             (H56) */
    char fNsys;          /* 341-342  I2    ---     Nsys      ? Number of entries with same CCDM       (H57) */
    char fNcomp;         /* 344-345  I2    ---     Ncomp     ? Number of components in this entry     (H58) */
    std::string fMultFlag;/*     347  A1    ---     MultFlag *[CGOVX] Double/Multiple Systems flag     (H59) */
    std::string fSource; /*     349  A1    ---     Source   *[PFILS] Astrometric source flag          (H60) */
    std::string fQual;   /*     351  A1    ---     Qual     *[ABCDS] Solution quality                 (H61) */
    std::string fm_HIP;  /* 353-354  A2    ---   m_HIP       Component identifiers                    (H62) */
    short int ftheta;    /* 356-358  I3    deg     theta     ? Position angle between components      (H63) */
    float frho;          /* 360-366  F7.3  arcsec  rho       ? Angular separation between components  (H64) */
    float fe_rho;        /* 368-372  F5.3  arcsec  e_rho     ? Standard error on rho                  (H65) */
    float fdHp;          /* 374-378  F5.2  mag     dHp       ? Magnitude difference of components     (H66) */
    float fe_dHp;        /* 380-383  F4.2  mag   e_dHp       ? Standard error on dHp                  (H67) */
    std::string fSurvey; /*     385  A1    ---     Survey    [S] Flag indicating a Survey Star        (H68) */
    std::string fChart;  /*     387  A1    ---     Chart    *[DG] Identification Chart                (H69) */
    std::string fNotes;  /*     389  A1    ---     Notes    *[DGPWXYZ] Existence of notes             (H70) */
    int fHD;             /* 391-396  I6    ---     HD        [1/359083]? HD number <III/135>          (H71) */
    std::string fBD;     /* 398-407  A10   ---     BD        Bonner DM <I/119>, <I/122>               (H72) */
    std::string fCoD;    /* 409-418  A10   ---     CoD       Cordoba Durchmusterung (DM) <I/114>      (H73) */
    std::string fCPD;    /* 420-429  A10   ---     CPD       Cape Photographic DM <I/108>             (H74) */
    float f_V_I_red;     /* 431-434  F4.2  mag     (V-I)red  V-I used for reductions                  (H75) */
    std::string fSpType; /* 436-447  A12   ---     SpType    Spectral type                            (H76) */
    std::string fr_SpType;/*     449  A1    ---   r_SpType   *[1234GKSX]? Source of spectral type      (H77) */
}; // end class HipRecord

#endif
